;==============================================================================
    include \masm32\include\masm32rt.inc
;==============================================================================

IDC_EDIT1   equ 101
IDC_EDIT2   equ 102
IDC_BUTTON1 equ 103
IDC_BUTTON2 equ 104
IDC_STATIC1 equ 105
IDC_STATIC2 equ 106
IDC_STATIC3 equ 107

;==============================================================================
    .data
      hInstance   dd 0
      hwndEdit    dd 0
      g_pointSize dd 0
      faceName    db "Lucida Console", 32 dup(0)
    .code
;==============================================================================

;------------------------------------------------------------------
; This is a modification of the MakeFont procedure from the MASM32
; examples, with the height and width specifications replaced with
; a point size specification.
;------------------------------------------------------------------

MakeFont proc pointSize:dword,weight:dword,italic:dword,lpFontName:dword

    invoke GetDC, 0
    invoke GetDeviceCaps, eax, LOGPIXELSY
    mul   pointSize
    xor   edx, edx
    mov   ecx, 72
    div   ecx

    invoke CreateFont,eax,0,NULL,NULL,weight,italic,NULL,NULL,
                      DEFAULT_CHARSET,OUT_TT_PRECIS,CLIP_DEFAULT_PRECIS,
                      PROOF_QUALITY,DEFAULT_PITCH or FF_DONTCARE,
                      lpFontName
    ret

MakeFont endp

;==============================================================================

DlgProc proc hwndDlg:dword, uMsg:dword, wParam:dword, lParam:dword

    SWITCH uMsg

      CASE WM_INITDIALOG

        invoke GetDlgItem, hwndDlg, IDC_EDIT1
        mov   hwndEdit, eax
        mov   g_pointSize, 10

        invoke SetDlgItemText, hwndDlg, IDC_EDIT2, addr faceName
        invoke MakeFont, g_pointSize, FW_NORMAL, 0, addr faceName
        invoke SendMessage, hwndEdit, WM_SETFONT, eax, TRUE
        invoke SetDlgItemInt, hwndDlg, IDC_STATIC3, g_pointSize, 0

      CASE WM_COMMAND

        SWITCH wParam

          CASE IDCANCEL

            invoke EndDialog, hwndDlg, 0

          CASE IDC_BUTTON1

            .if g_pointSize < 36
              inc g_pointSize
              invoke GetDlgItemText, hwndDlg, IDC_EDIT2, addr faceName, 32
              invoke MakeFont, g_pointSize, FW_NORMAL, 0, addr faceName
              invoke SendMessage, hwndEdit, WM_SETFONT, eax, TRUE
              invoke SetDlgItemInt, hwndDlg, IDC_STATIC3, g_pointSize, 0
            .endif

          CASE IDC_BUTTON2

            .if g_pointSize > 1
              dec g_pointSize
              invoke GetDlgItemText, hwndDlg, IDC_EDIT2, addr faceName, 32
              invoke MakeFont, g_pointSize, FW_NORMAL, 0, addr faceName
              invoke SendMessage, hwndEdit, WM_SETFONT, eax, TRUE
              invoke SetDlgItemInt, hwndDlg, IDC_STATIC3, g_pointSize, 0
            .endif

        ENDSW

      CASE WM_CLOSE

        invoke EndDialog, hwndDlg, 0

    ENDSW

    xor   eax, eax
    ret

DlgProc endp

;==============================================================================
start:
;==============================================================================

    invoke GetModuleHandle, NULL
    mov   hInstance, eax

    Dialog "Test", \
           "MS Sans Serif",10, \
           WS_OVERLAPPED or WS_SYSMENU or DS_CENTER, \
           7,0,0,160,120,1024

    DlgEdit ES_MULTILINE or ES_WANTRETURN or WS_BORDER or \
            ES_AUTOHSCROLL or ES_AUTOVSCROLL or \
            WS_HSCROLL or WS_VSCROLL,5,5,147,60,IDC_EDIT1

    DlgStatic "Face Name:",SS_LEFT,6,73,40,10,IDC_STATIC1
    DlgEdit WS_BORDER,47,73,105,10,IDC_EDIT2

    DlgStatic "Point Size:",SS_LEFT,6,92,41,10,IDC_STATIC2
    DlgStatic 0,SS_CENTER or WS_BORDER,43,92,12,10,IDC_STATIC3
    DlgButton "Increase",0,74,91,35,12,IDC_BUTTON1
    DlgButton "Decrease",0,117,91,35,12,IDC_BUTTON2

    CallModalDialog hInstance,0,DlgProc,NULL

    exit
;==============================================================================
end start
